Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace ErrorHandlingInWF
    Public Class ConsoleMenu
        Private actions As Dictionary(Of String, Action)
        Private selectedOption As Integer = 0

        Public Sub New(ByVal options As Dictionary(Of String, Action))
            actions = options
        End Sub


        Public Sub Run()
            DisplayChoices()
            ReadInput()
            ExecutionChoice()
        End Sub

        Private Sub ReadInput()
            Dim input As String = Console.ReadLine()
            Dim [option] As Integer = 0
            Do While Not Integer.TryParse(input, [option])
                Console.WriteLine("You must enter a valid integer and press Enter")
                input = Console.ReadLine()
            Loop

            selectedOption = [option]
        End Sub

        Private Sub ExecutionChoice()
            Dim key As String = actions.Keys.Skip(selectedOption - 1).Take(1).First()
            Dim selectedAction As Action = actions(key)
            Console.WriteLine(Constants.vbLf & "  Executing option ({0})" & Constants.vbLf, key)
            selectedAction()
        End Sub

        Private Sub DisplayChoices()
            Console.WriteLine("Select an option:")

            Dim choiceIndex As Integer = 1
            For Each key As String In actions.Keys
                Console.WriteLine("{0}: {1}", choiceIndex, key)
                choiceIndex += 1
            Next key

            Console.Write(Constants.vbLf & "Enter your choice: ")
        End Sub


    End Class
End Namespace
