Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Workflow.ComponentModel
Imports System.ComponentModel
Imports System.Workflow.ComponentModel.Design
Imports System.ComponentModel.Design

Namespace CustomActivities
	<Designer(GetType(SequenceDesigner), GetType(IDesigner))> _
	Public Class CustomSequence
		Inherits CompositeActivity
		Private index As Integer = 0

		Protected Overrides Function Execute(ByVal executionContext As ActivityExecutionContext) As ActivityExecutionStatus
			If EnabledActivities.Count = 0 Then
				Return ActivityExecutionStatus.Closed
			End If

			Dim child As Activity = EnabledActivities(index)

			AddHandler child.Closed, AddressOf child_Closed
			AddHandler child.Faulting, AddressOf child_Faulting
			executionContext.ExecuteActivity(child)

			Return ActivityExecutionStatus.Executing

		End Function

		Private Sub child_Faulting(ByVal sender As Object, ByVal e As ActivityExecutionStatusChangedEventArgs)
			Console.WriteLine("Child {1} faulting: {0}", Me.ExecutionStatus, e.Activity.Name)
			RemoveHandler e.Activity.Faulting, AddressOf child_Faulting
		End Sub

		Private Sub child_Closed(ByVal sender As Object, ByVal e As ActivityExecutionStatusChangedEventArgs)
			RemoveHandler e.Activity.Closed, AddressOf child_Closed

			Dim ctx As ActivityExecutionContext = TryCast(sender, ActivityExecutionContext)

			Console.WriteLine("Child closed: {0}", Me.ExecutionStatus)
'INSTANT VB TODO TASK: Assignments within expressions are not supported in VB.NET
'ORIGINAL LINE: if (++index == EnabledActivities.Count)
			If ++index = EnabledActivities.Count Then
				ctx.CloseActivity()

			Else
				If Me.ExecutionStatus = ActivityExecutionStatus.Executing Then
					Dim child As Activity = EnabledActivities(index)

					AddHandler child.Closed, AddressOf child_Closed
					AddHandler child.Faulting, AddressOf child_Faulting
					ctx.ExecuteActivity(child)
				End If
			End If

		End Sub


		Protected Overrides Function HandleFault(ByVal executionContext As ActivityExecutionContext, ByVal exception As Exception) As ActivityExecutionStatus
			Console.WriteLine("Sequence Handling Fault")
			Return MyBase.HandleFault(executionContext, exception)
		End Function

		Protected Overrides Function Cancel(ByVal executionContext As ActivityExecutionContext) As ActivityExecutionStatus
			Console.WriteLine("Sequence Canceling")
			Return MyBase.Cancel(executionContext)
		End Function
	End Class
End Namespace
