Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Workflow.ComponentModel
Imports System.ComponentModel

Namespace ErrorHandlingInWF
	Public Class CustomThrowActivity
		Inherits Activity

		Private privateNumberOfTimesToThrow As Integer
		<Category("Retry")> _
		Public Property NumberOfTimesToThrow() As Integer
			Get
				Return privateNumberOfTimesToThrow
			End Get
			Set(ByVal value As Integer)
				privateNumberOfTimesToThrow = value
			End Set
		End Property

		Private privateExceptionText As String
		<Category("Retry")> _
		Public Property ExceptionText() As String
			Get
				Return privateExceptionText
			End Get
			Set(ByVal value As String)
				privateExceptionText = value
			End Set
		End Property


		Public Shared ThrowIndicatorProperty As DependencyProperty = DependencyProperty.Register("ThrowIndicator", GetType(Integer), GetType(CustomThrowActivity))

		<System.ComponentModel.DescriptionAttribute("ThrowIndicator"), Category("Retry"), System.ComponentModel.BrowsableAttribute(True), System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)> _
		Public Property ThrowIndicator() As Integer
			Get
				Return (CInt(Fix(MyBase.GetValue(CustomThrowActivity.ThrowIndicatorProperty))))
			End Get
			Set(ByVal value As Integer)
				MyBase.SetValue(CustomThrowActivity.ThrowIndicatorProperty, value)
			End Set
		End Property

		Protected Overrides Function Execute(ByVal executionContext As ActivityExecutionContext) As ActivityExecutionStatus
            If ThrowIndicator < NumberOfTimesToThrow Then
                ThrowIndicator += 1
                Throw New ApplicationException(ExceptionText)
            Else
                ThrowIndicator += 1
                Console.WriteLine("Custom throw NOT throwing exception")
            End If
			Return ActivityExecutionStatus.Closed
		End Function

		Protected Overrides Function HandleFault(ByVal executionContext As ActivityExecutionContext, ByVal exception As Exception) As ActivityExecutionStatus
			Console.WriteLine("Handling fault in CustomThrow")
			Return MyBase.HandleFault(executionContext, exception)
		End Function
	End Class
End Namespace
